<script setup lang="ts">
import type { HeaderPrep, RefSearchNav } from '~/components/pub/my-ui/data/types'

// #region Imports
import RecordConfirmation from '~/components/pub/my-ui/confirmation/record-confirmation.vue'
import { ActionEvents } from '~/components/pub/my-ui/data/types'

import Filter from '~/components/pub/my-ui/nav-header/filter.vue'
import Header from '~/components/pub/my-ui/nav-header/prep.vue'
import { usePaginatedList } from '~/composables/usePaginatedList'
import { getList, remove } from '~/services/surgery-report.service'
import { toast } from '~/components/pub/ui/toast'
import type { Encounter } from '~/models/encounter'
import WarningAlert from '~/components/pub/my-ui/alert/warning-alert.vue'
import Dialog from '~/components/pub/my-ui/modal/dialog.vue'
// #endregion

// #region State
const props = withDefaults(defineProps<{
  encounter_id: number
  redirectToForm?: (myRecord_id?: any) => void
  redirectToDetail?: (myRecord_id: string|number) => void
}>(), {
  redirectToForm: () => { },
  redirectToDetail: () => { }
})

const { data, isLoading, paginationMeta, searchInput, handlePageChange, handleSearch, fetchData } = usePaginatedList({
  fetchFn: (params) => getList({ ...params, includes: 'specialist,subspecialist,doctor-employee-person', }),
  entityName: 'surgery-report',
})

const isHistoryDialogOpen = ref(false)
const isFilterDialogOpen = ref(false)
const isRecordConfirmationOpen = ref(false)
const summaryLoading = ref(false)
const isRequirementsMet = ref(true)

const recId = ref<number>(0)
const recAction = ref<string>('')
const recItem = ref<any>(null)

const headerPrep: HeaderPrep = {
  title: "Laporan Operasi",
  icon: 'i-lucide-history',
  addNav: {
    label: "Laporan Operasi",
    onClick: () => {
      props.redirectToForm()
    },
  },
}
const refSearchNav: RefSearchNav = {
  onClick: () => {
    isFilterDialogOpen.value = true
  },
  onInput: (val: string) => {
    searchInput.value = val
  },
  onClear: () => {
    searchInput.value = ''
  },
}
  headerPrep.components = [
    {
      component: defineAsyncComponent(() => import('~/components/app/surgery-report/_common/btn-history.vue')),
      props: {  }
    },
  ];
// #endregion

// #region Lifecycle Hooks
onMounted(() => {
  getListData()
})
// #endregion

// #region Functions
async function getListData() {
  try {
    summaryLoading.value = true
    await new Promise((resolve) => setTimeout(resolve, 500))
  } catch (error) {
    console.error('Error fetching Data:', error)
  } finally {
    summaryLoading.value = false
  }
}

// Handle confirmation result
function handleFiltering(value: any) {
  isFilterDialogOpen.value = false
}
async function handleConfirmDelete(record: any, action: string) {
  if (action === 'delete' && record?.id) {
    try {
      const result = await remove(record.id)
      if (result.success) {
        toast({ title: 'Berhasil', description: 'Data berhasil dihapus', variant: 'default' })
        await fetchData()
      } else {
        toast({ title: 'Gagal', description: `Data gagal dihapus`, variant: 'destructive' })
      }
    } catch (error) {
      toast({ title: 'Gagal', description: `Something went wrong`, variant: 'destructive' })
    }
  }
}

function handleCancelConfirmation() {
  // Reset record state when cancelled
  recId.value = 0
  recAction.value = ''
  recItem.value = null
}
// #endregion

// #region Provide
provide('rec_id', recId)
provide('rec_action', recAction)
provide('rec_item', recItem)
provide('table_data_loader', isLoading)
provide('isHistoryDialogOpen', isHistoryDialogOpen)
// #endregion

// #region Watchers
watch([recId, recAction], () => {
  switch (recAction.value) {
    case ActionEvents.showDetail:
      props.redirectToDetail(recId.value)
      break

    case ActionEvents.showEdit:
      props.redirectToForm(recId.value)
      break

    case ActionEvents.showConfirmDelete:
      isRecordConfirmationOpen.value = true
      break
  }
})
// #endregion
</script>

<template>
  <WarningAlert v-if="!isRequirementsMet"
    class="mb-5"
    text="Syarat pembuatan Laporan Operasi belum terpenuhi"
    :description="[
      'Lanjutan Penatalaksanaan Pasien harus pulang/KRS.',
      'Status Resume Medis harus tervalidasi.'
    ]" />

  <div v-else>
    <Header :prep="headerPrep" />

    <Filter
      :prep="headerPrep"
      :ref-search-nav="refSearchNav"
      :enable-export="false"
    />

    <AppSurgeryReportList :data="data" :pagination-meta="paginationMeta" @page-change="handlePageChange" />

    <Dialog v-model:open="isFilterDialogOpen" title="Filter" size="lg">
      <AppSurgeryReportCommonFilter @submit="handleFiltering" />
    </Dialog>

    <Dialog v-model:open="isHistoryDialogOpen" title="History">
      <AppSurgeryReportCommonHistoryDialog />
    </Dialog>

    <RecordConfirmation v-model:open="isRecordConfirmationOpen" action="delete" :record="recItem"
      @confirm="handleConfirmDelete" @cancel="handleCancelConfirmation">
      <template #default="{ record }">
        <div class="text-sm">
          <p>
            <strong>ID:</strong>
            {{ record?.id }}
          </p>
          <p v-if="record?.firstName">
            <strong>Nama:</strong>
            {{ record.firstName }}
          </p>
          <p v-if="record?.code">
            <strong>Kode:</strong>
            {{ record.cellphone }}
          </p>
        </div>
      </template>
    </RecordConfirmation>
  </div>
</template>
